const _ = require('lodash');

class CookieUtils {
  static generateUrlRedirect(
    { url, quotationIdentifier, companyId, conversationId, packageId, packageName },
    config,
  ) {
    if (!config.COOKIES_ENDPOINT) {
      return url;
    }

    const queryParameters = _.chain({
      ck__ASKSUITE__QuotationIdentifier: quotationIdentifier,
      ck__ASKSUITE__ConversationId: conversationId,
      ck__ASKSUITE__CompanyId: companyId,
      ck__ASKSUITE__PackageId: packageId,
      ck__ASKSUITE__PackageName: packageName ? encodeURIComponent(packageName) : packageName,
      ck__ASKSUITE__LastUrl: encodeURIComponent(url),
      url: encodeURIComponent(url),
    })
      .omitBy(_.isNil)
      .map((val, key) => `${key}=${val}`)
      .join('&')
      .value();

    return `${config.COOKIES_ENDPOINT}/redirect?${queryParameters}`;
  }
}

module.exports = CookieUtils;
